/**
***     WebApp.c
***
***     ̃\[XR[h́AG[XgbvTXyhȂǂ̏Ă܂B
***     Copyright (C) 2006 SophiaCradle Incorporated.
***     All rights reserved.
**/

#include "AEEModGen.h"
#include "AEEAppGen.h"
#include "AEEStdLib.h"
#include "AEEShell.h"
#include "Common.h"
#include "WebApp.bid"
#include "AEEWeb.h"

typedef struct WebApp WebApp;

typedef struct WebAction {
    WebApp* parent;
    AEECallback callback;
    IWebResp* webresp; // IWebResp C^[tF[X̃CX^Xϐ
    IGetLine* getline; // IGetLine C^[tF[X̃CX^Xϐ
} WebAction;

struct WebApp {
    AEEApplet a; // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱ƁB
    Common common; // ʕ`p

    IWeb* web;           // IWeb C^[tF[X̃CX^Xϐ
    WebAction webaction; // R[obN֐ WebAction_GotResp ̈
};

static boolean WebApp_HandleEvent(WebApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam);
static boolean OnAppStart(WebApp* app);
static boolean OnAppStop(WebApp* app);
static boolean OnKey(WebApp* app, uint16 key);
static void WebAction_Start(WebAction* webaction, char* pszUrl);
static void WebAction_GotResp(void* p);
static void WebAction_Header(void* p, const char* name, GetLine* val);
static void WebAction_Status(void* p, WebStatus webstatus, void* val);
static void WebAction_Stop(WebAction* webaction);
static void WebAction_ReadLines(void* p);

int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
    *ppObj = NULL;
    if (ClsId == AEECLSID_WEBAPP) {
        if (AEEApplet_New(sizeof(WebApp), ClsId, pIShell, po, (IApplet**)ppObj, (AEEHANDLER)WebApp_HandleEvent, NULL) == TRUE) {
            return AEE_SUCCESS;
        }
    }
    return EFAILED;
}

static boolean WebApp_HandleEvent(WebApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    switch (eCode) {
        case EVT_APP_START:
            return OnAppStart(app);

        case EVT_APP_STOP:
            return OnAppStop(app);

        case EVT_KEY:
            return OnKey(app, wParam);
    }
    return FALSE;
}

// AvbgJnƂɌĂяoB
static boolean OnAppStart(WebApp* app)
{
    IShell* shell = app->a.m_pIShell;
    IDisplay* display = app->a.m_pIDisplay;
    WebOpt webopts[2];

    app->web = NULL;
    ISHELL_CreateInstance(shell, AEECLSID_WEB, (void**)&app->web);

    // ڑ̃^CAEgԂ̐ݒ (ms)
    webopts[0].nId = WEBOPT_CONNECTTIMEOUT;
    webopts[0].pVal = (void*)10000;

    // WebOpt I}[N
    webopts[1].nId = WEBOPT_END;

    // IvVݒ
    IWEB_AddOpt(app->web, webopts);

    app->webaction.parent = app;

    COMMON_Init(&app->common, display, shell, 32768);
    COMMON_WriteString(&app->common, "Push Select Key...\n");
    COMMON_Draw(&app->common);
    return TRUE;
}

// AvbgIƂɌĂяoB
static boolean OnAppStop(WebApp* app)
{
    CALLBACK_Cancel(&app->webaction.callback);
    IWEB_Release(app->web);
    COMMON_Free(&app->common);
    return TRUE;
}

// L[ꂽƂɌĂяoB
static boolean OnKey(WebApp* app, uint16 key)
{
    switch (key) {
        case AVK_SELECT:
            // ʐMJn
            WebAction_Start(&app->webaction, "http://www.google.com");
            return TRUE;

        case AVK_DOWN:
            COMMON_NextLine(&app->common);
            COMMON_Draw(&app->common);
            return TRUE;

        case AVK_UP:
            COMMON_PreviousLine(&app->common);
            COMMON_Draw(&app->common);
            return TRUE;
    }
    return FALSE;
}

// HTTP ʐMJn
static void WebAction_Start(WebAction* webaction, char* url)
{
    WebApp* app = webaction->parent;

    CALLBACK_Init(&webaction->callback, WebAction_GotResp, webaction);
    IWEB_GetResponse(app->web,
                    (app->web, &webaction->webresp, &webaction->callback, url,
                    WEBOPT_HANDLERDATA, webaction,
                    WEBOPT_HEADER, "X-Method: GET\r\n",
                    WEBOPT_HEADERHANDLER, WebAction_Header,
                    WEBOPT_STATUSHANDLER, WebAction_Status,
                    WEBOPT_END));
    return;
}

// bZ[W̎擾Jn
static void WebAction_GotResp(void* p)
{
    WebAction* webaction = (WebAction*)p;
    WebApp* app = webaction->parent;
    WebRespInfo* info;
    char buffer[80];

    info = IWEBRESP_GetInfo(webaction->webresp);
    SPRINTF(buffer, "** got response...\n** info code: %d\n", info->nCode);
    COMMON_WriteString(&app->common, buffer);
    COMMON_Draw(&app->common);

    if (info->pisMessage != NULL) {
        ISourceUtil* util = NULL;

        ISHELL_CreateInstance(app->a.m_pIShell, AEECLSID_SOURCEUTIL, (void**)&util);
        ISOURCEUTIL_GetLineFromSource(util, info->pisMessage, 1100, &webaction->getline);
        ISOURCEUTIL_Release(util);
    }
    if (webaction->getline != NULL) {
        WebAction_ReadLines(webaction);
    }
    else {
        COMMON_WriteString(&app->common, "** no response\n");
        COMMON_Draw(&app->common);
        WebAction_Stop(webaction);
    }
    return;
}

// wb_[
static void WebAction_Header(void* p, const char* name, GetLine* val)
{
    WebAction* webaction = (WebAction*)p;
    WebApp* app = webaction->parent;

    if (name != NULL) {
        COMMON_WriteString(&app->common, name);
        COMMON_WriteString(&app->common, ":");
        COMMON_WriteString(&app->common, val->psz);
        COMMON_WriteString(&app->common, "\n");
    }
    else {
        COMMON_WriteString(&app->common, val->psz);
        COMMON_WriteString(&app->common, "\n");
    }
    COMMON_Draw(&app->common);
    return;
}

// Ԏ擾
static void WebAction_Status(void* p, WebStatus webstatus, void* val)
{
    char* string = NULL;
    WebAction* webaction = (WebAction*)p;
    (void)val;

    switch (webstatus) {
        case WEBS_CANCELLED:
            string = "** cancelled...\n";
            break;

        case WEBS_GETHOSTBYNAME:
            string = "** finding host...\n";
            break;

        case WEBS_CONNECT:
            string = "** connecting...\n";
            break;

        case WEBS_SENDREQUEST:
            string = "** sending...\n";
            break;

        case WEBS_READRESPONSE:
            string = "** receiving...\n";
            break;

        case WEBS_GOTREDIRECT:
            string = "** redirect...\n";
            break;

        case WEBS_CACHEHIT:
            string = "** cache hit...\n";
            break;
    }
    if (string != NULL) {
        COMMON_WriteString(&webaction->parent->common,string);
        COMMON_Draw(&webaction->parent->common);
    }
    return;
}

// ʐMI
static void WebAction_Stop(WebAction* webaction)
{
    CALLBACK_Cancel(&webaction->callback);
    // e
    if (webaction->getline != NULL) {
       IGETLINE_Release(webaction->getline);
       webaction->getline = NULL;
    }
    if (webaction->webresp != NULL) {
       IWEBRESP_Release(webaction->webresp);
       webaction->webresp = NULL;
    }
    return;
}

// bZ[W擾
static void WebAction_ReadLines(void* p)
{
    int value;
    GetLine getline;
    WebAction* webaction = (WebAction*)p;
    WebApp* app = webaction->parent;

    //  LF ܂łsƂāAgetline \̂ɓǂݍށB
    value = IGETLINE_GetLine(webaction->getline, &getline, IGETLINE_LF);
    if (value == IGETLINE_WAIT) {
        // ubNꂽꍇ́AR[obN֐ƂĎgēxo^B
        CALLBACK_Init(&webaction->callback, WebAction_ReadLines, webaction);
        IGETLINE_Peekable(webaction->getline, &webaction->callback);
    }
    else {
        COMMON_WriteString(&app->common, getline.psz);
        COMMON_WriteString(&app->common, "\n");
        if (!IGETLINE_Exhausted(value)) {
            // ǂݍ݂ĂȂꍇAR[obNo^
            CALLBACK_Init(&webaction->callback, WebAction_ReadLines, webaction);
            IGETLINE_Readable(webaction->getline, &webaction->callback);
        }
        else {
            // ǂݍ݊
            COMMON_WriteString(&app->common, (value == IGETLINE_ERROR) ? ("\n** error\n") : ("\n** end\n"));
            COMMON_Draw(&app->common);
            WebAction_Stop(webaction);
        }
    }
    return;
}
